/* 
 * GoalieAI.java 1.0 2002-09-03
 *
 *  2002 Jouni Smed
 *
 * This software is provided for educational and non-commercial use only.
 *
 */
import fi.utu.cs.hockey.ai.*;

public class GoalieAI extends AI implements Constants
	{
	public void react()
		{
		if (!isGameStopped())
			{
			double[] puck = puck();
			double[] me = player(true, getPosition());
			
			double range = 1.2; 
			double a = puck[X_COORDINATE];
			double b = puck[Y_COORDINATE] - OUR_GOAL_LINE;
			double c = Math.sqrt(a * a + b * b);
			double x = a * (range / c);
			double y = b * (range / c);
			if (y < OUR_GOAL_LINE)
				{
				y = OUR_GOAL_LINE;
				x = (x > 0.0 ? 1.0 : -1.0) * range;
				}
			head(headingTo(x, y + OUR_GOAL_LINE));
			
			double p = Math.abs(x - me[X_COORDINATE]) + 
								 Math.abs(y - me[Y_COORDINATE]);
			p = (p > 1.0 ? 1.0 : p);
			dash(p);
		
			if (isPuckWithinReach()) 
				{
				PlayerIterator pit = iteratorAll();
				double ourMinY = Double.POSITIVE_INFINITY;
				int ourMinPos = 0;
				double theirMinY = Double.POSITIVE_INFINITY;
				while (pit.hasNext())
					{
					int pos = pit.next();
					if (pos != GOALKEEPER)
						{
						double ourY = player(true, pos)[Y_COORDINATE];
						double theirY = player(false, pos)[Y_COORDINATE];
						if (ourY < ourMinY) 
							{
							ourMinY = ourY;
							ourMinPos = pos;
							}
						if (theirY < theirMinY) 
							{
							theirMinY = theirY;
							}
						}
					}
				if (ourMinY < theirMinY)
					{
					head(headingTo(player(true, ourMinPos)));
					shoot(1.0);
					}
				else
					{
					keepPuck();
					}
				}
			}
		}		
	}